import FullTsAppConfig from './FullTsAppConfig';
import { ITsRpcClient, TsRpcPtl } from 'tsrpc-protocol';
import SuperPromise from 'k8w-super-promise';
import { RpcClient } from 'tsrpc-browser';
import { RouteComponentProps } from 'react-router-dom';
export default class FullTsApp implements ITsRpcClient {
    protected rpcClient: RpcClient;
    readonly config: FullTsAppConfig;
    /**
     * params from route match
     */
    params: any;
    /**
     * params from parse query string
     */
    query: {
        [key: string]: string;
    };
    history: RouteComponentProps<any>['history'];
    location: RouteComponentProps<any>['location'];
    match: RouteComponentProps<any>['match'];
    constructor(config: FullTsAppConfig);
    protected _apiRequests: {
        [sn: number]: SuperPromise<any>;
    };
    callApi<Req, Res>(ptl: TsRpcPtl<Req, Res>, req?: Req): SuperPromise<Res>;
    protected _domTarget: HTMLElement;
    render(domTarget: HTMLElement): void;
    dispose(): void;
    cancelAllApiRequest(): void;
}
