/// <reference types="react" />
import * as React from "react";
import { ITsRpcClient, TsRpcPtl } from "tsrpc-protocol";
import SuperPromise from "k8w-super-promise";
import FullTsApp from './FullTsApp';
import * as PropTypes from 'prop-types';
export default class FullTsComponent<P = {}, S = {}> extends React.Component<P, S> implements ITsRpcClient {
    static contextTypes: {
        fullTsApp: PropTypes.Requireable<any>;
    };
    constructor(props?: P, context?: any);
    protected _apiRequests: {
        [sn: number]: SuperPromise<any>;
    };
    callApi<Req, Res>(ptl: TsRpcPtl<Req, Res>, req?: Req): SuperPromise<Res>;
    /**
     * Current FullTSApp Instance
     */
    readonly app: FullTsApp;
    history: any;
    location: any;
    params: any;
    query: {
        [key: string]: string;
    };
    private _componentWillUnmount();
    private _cancelAllApiRequest();
}
