"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import * as React from "react";
import FullTsApp from './FullTsApp';
import { RpcClient } from "tsrpc-browser";
import * as PropTypes from 'prop-types';
var FullTsComponent = /** @class */ (function (_super) {
    __extends(FullTsComponent, _super);
    function FullTsComponent(props, context) {
        var _this = _super.call(this, props, context) || this;
        _this._apiRequests = {};
        //componentWillUnmount cancel all api requests
        if (_this.componentWillUnmount) {
            var originalFunc_1 = _this.componentWillUnmount;
            _this.componentWillUnmount = function () {
                _this._componentWillUnmount();
                originalFunc_1();
            };
        }
        else {
            _this.componentWillUnmount = _this._componentWillUnmount;
        }
        return _this;
    }
    FullTsComponent.prototype.callApi = function (ptl, req) {
        var _this = this;
        //ADD TO CONN POOL AND POP WHEN DISPOSE
        var conn = this.app.callApi(ptl, req);
        var sn = RpcClient.getLastReqSn();
        this._apiRequests[sn] = conn;
        //pop when complete
        conn.always(function () {
            delete _this._apiRequests[sn];
        }).onCancel(function () {
            delete _this._apiRequests[sn];
        });
        return conn;
    };
    Object.defineProperty(FullTsComponent.prototype, "app", {
        /**
         * Current FullTSApp Instance
         */
        get: function () {
            return this.context.fullTsApp;
        },
        enumerable: true,
        configurable: true
    });
    FullTsComponent.prototype._componentWillUnmount = function () {
        this._cancelAllApiRequest();
    };
    FullTsComponent.prototype._cancelAllApiRequest = function () {
        for (var sn in this._apiRequests) {
            if (this._apiRequests.hasOwnProperty(sn)) {
                this._apiRequests[sn].cancel();
            }
        }
    };
    FullTsComponent.contextTypes = {
        fullTsApp: PropTypes.instanceOf(FullTsApp)
    };
    return FullTsComponent;
}(React.Component));
export default FullTsComponent;
